-- http://allaboutfpga.com/vhdl-testbench-tutorial/
-- Uppsala University - Digital Electronics Design with VHDL, 1FA326
-- Copyright (c) 2020 Henrik Alfken <henke.uu.se@inbox.lv>
library ieee;
use ieee.std_logic_1164.all;

entity tbUpDownCounter is end tbUpDownCounter;  -- Closed system.
architecture rtl of tbUpDownCounter is
  constant clkPeriod : time := 20 ns;
  signal tbRST    : std_logic := '0';
  signal tbUpDown : std_logic := '0';
  signal tbCLK    : std_logic := '0';
  signal tbCntr   : std_logic_vector(3 downto 0);
  component upDownCounter port (
    clock   : in std_logic;
    reset   : in std_logic;
    upDown  : in std_logic;
    counter :out std_logic_vector(3 downto 0));
  end component;
begin -- Instantiate the Unit Under Test:
  unitUnderTest : upDownCounter port map (
    clock   => tbCLK,
    reset   => tbRST,
    upDown  => tbUpDown,
    counter => tbCntr
  );  -- End of port map.
  clockProcess : process begin
    tbCLK <= '0';
    wait for clkPeriod/2;
    tbCLK <= '1';
    wait for clkPeriod/2;
  end process clockProcess;
  stimulusProcess : process begin
    wait for clkPeriod;
    tbRST <= '1';
    wait for clkPeriod;
    tbRST <= '0';
    tbUpDown <= '0';
    wait for clkPeriod*10;
    tbUpDown <= '1';
    wait;
  end process stimulusProcess;
end rtl;
